import GC from '@grapecity/spread-sheets'

function HTMLCellType() {}
		HTMLCellType.prototype = new GC.Spread.Sheets.CellTypes.Text;
		HTMLCellType.prototype.paint = function (ctx, value, x, y, w, h, style, context) {
			var DOMURL = window.URL || window.webkitURL || window;
			var cell = context.sheet.getCell(context.row, context.col);
      var tag = cell.tag();
      if (tag) {
        tag = typeof tag === 'string' ? JSON.parse(tag) : tag
      }
        if (tag && tag['svg']) {
				try{
					ctx.save();
					ctx.rect(x, y, w, h);
					ctx.clip();
					ctx.drawImage(tag['svg'], x + 2, y + 2)
          ctx.restore();
          delete tag['svg']
					cell.tag(tag);
					return;
				}
				catch(err){
					GC.Spread.Sheets.CustomCellType.prototype.paint.apply(this, [ctx, "#HTMLError", x, y, w, h, style, context])
					delete tag['svg']
					cell.tag(tag);
					return;
				}
			}
			var svgPattern = '<svg xmlns="http://www.w3.org/2000/svg" width="{0}" height="{1}">' +
				'<foreignObject width="100%" height="100%"><div xmlns="http://www.w3.org/1999/xhtml" style="font:{2}">{3}</div></foreignObject></svg>';

			var data = svgPattern.replace("{0}", w).replace("{1}", h).replace("{2}", style.font).replace("{3}", value);
			var doc = document.implementation.createHTMLDocument("");
			doc.write(data);
			// Get well-formed markup
			data = (new XMLSerializer()).serializeToString(doc.body.children[0]);

			let img = new Image();
			//var svg = new Blob([data], {type: 'image/svg+xml;charset=utf-8'});
			//var url = DOMURL.createObjectURL(svg);
			//img.src = url;
      img.src = 'data:image/svg+xml;base64,'+window.btoa(data);
      console.log(tag)
      if (!tag) {
        tag = {}
      }
      
      tag['svg'] = img
			cell.tag(tag);
			tag['svg'].onload = function () {
				context.sheet.repaint(new GC.Spread.Sheets.Rect(x, y, w, h));
			}
    };
    HTMLCellType.prototype.paintValue = function(){return;}
    export default HTMLCellType